/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the CloneResult type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CloneResult{}

// CloneResult struct for CloneResult
type CloneResult struct {
	ChannelsNotAvailable []string `json:"channels_not_available,omitempty"`
	ValidationErrors []string `json:"validation_errors,omitempty"`
	Issues []string `json:"issues,omitempty"`
	NewScripts []ClonedScript `json:"new_scripts,omitempty"`
	Success bool `json:"success"`
}

// NewCloneResult instantiates a new CloneResult object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCloneResult(success bool) *CloneResult {
	this := CloneResult{}
	this.Success = success
	return &this
}

// NewCloneResultWithDefaults instantiates a new CloneResult object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCloneResultWithDefaults() *CloneResult {
	this := CloneResult{}
	return &this
}

// GetChannelsNotAvailable returns the ChannelsNotAvailable field value if set, zero value otherwise.
func (o *CloneResult) GetChannelsNotAvailable() []string {
	if o == nil || IsNil(o.ChannelsNotAvailable) {
		var ret []string
		return ret
	}
	return o.ChannelsNotAvailable
}

// GetChannelsNotAvailableOk returns a tuple with the ChannelsNotAvailable field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CloneResult) GetChannelsNotAvailableOk() ([]string, bool) {
	if o == nil || IsNil(o.ChannelsNotAvailable) {
		return nil, false
	}
	return o.ChannelsNotAvailable, true
}

// HasChannelsNotAvailable returns a boolean if a field has been set.
func (o *CloneResult) HasChannelsNotAvailable() bool {
	if o != nil && !IsNil(o.ChannelsNotAvailable) {
		return true
	}

	return false
}

// SetChannelsNotAvailable gets a reference to the given []string and assigns it to the ChannelsNotAvailable field.
func (o *CloneResult) SetChannelsNotAvailable(v []string) {
	o.ChannelsNotAvailable = v
}

// GetValidationErrors returns the ValidationErrors field value if set, zero value otherwise.
func (o *CloneResult) GetValidationErrors() []string {
	if o == nil || IsNil(o.ValidationErrors) {
		var ret []string
		return ret
	}
	return o.ValidationErrors
}

// GetValidationErrorsOk returns a tuple with the ValidationErrors field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CloneResult) GetValidationErrorsOk() ([]string, bool) {
	if o == nil || IsNil(o.ValidationErrors) {
		return nil, false
	}
	return o.ValidationErrors, true
}

// HasValidationErrors returns a boolean if a field has been set.
func (o *CloneResult) HasValidationErrors() bool {
	if o != nil && !IsNil(o.ValidationErrors) {
		return true
	}

	return false
}

// SetValidationErrors gets a reference to the given []string and assigns it to the ValidationErrors field.
func (o *CloneResult) SetValidationErrors(v []string) {
	o.ValidationErrors = v
}

// GetIssues returns the Issues field value if set, zero value otherwise.
func (o *CloneResult) GetIssues() []string {
	if o == nil || IsNil(o.Issues) {
		var ret []string
		return ret
	}
	return o.Issues
}

// GetIssuesOk returns a tuple with the Issues field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CloneResult) GetIssuesOk() ([]string, bool) {
	if o == nil || IsNil(o.Issues) {
		return nil, false
	}
	return o.Issues, true
}

// HasIssues returns a boolean if a field has been set.
func (o *CloneResult) HasIssues() bool {
	if o != nil && !IsNil(o.Issues) {
		return true
	}

	return false
}

// SetIssues gets a reference to the given []string and assigns it to the Issues field.
func (o *CloneResult) SetIssues(v []string) {
	o.Issues = v
}

// GetNewScripts returns the NewScripts field value if set, zero value otherwise.
func (o *CloneResult) GetNewScripts() []ClonedScript {
	if o == nil || IsNil(o.NewScripts) {
		var ret []ClonedScript
		return ret
	}
	return o.NewScripts
}

// GetNewScriptsOk returns a tuple with the NewScripts field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CloneResult) GetNewScriptsOk() ([]ClonedScript, bool) {
	if o == nil || IsNil(o.NewScripts) {
		return nil, false
	}
	return o.NewScripts, true
}

// HasNewScripts returns a boolean if a field has been set.
func (o *CloneResult) HasNewScripts() bool {
	if o != nil && !IsNil(o.NewScripts) {
		return true
	}

	return false
}

// SetNewScripts gets a reference to the given []ClonedScript and assigns it to the NewScripts field.
func (o *CloneResult) SetNewScripts(v []ClonedScript) {
	o.NewScripts = v
}

// GetSuccess returns the Success field value
func (o *CloneResult) GetSuccess() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Success
}

// GetSuccessOk returns a tuple with the Success field value
// and a boolean to check if the value has been set.
func (o *CloneResult) GetSuccessOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Success, true
}

// SetSuccess sets field value
func (o *CloneResult) SetSuccess(v bool) {
	o.Success = v
}

func (o CloneResult) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CloneResult) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ChannelsNotAvailable) {
		toSerialize["channels_not_available"] = o.ChannelsNotAvailable
	}
	if !IsNil(o.ValidationErrors) {
		toSerialize["validation_errors"] = o.ValidationErrors
	}
	if !IsNil(o.Issues) {
		toSerialize["issues"] = o.Issues
	}
	if !IsNil(o.NewScripts) {
		toSerialize["new_scripts"] = o.NewScripts
	}
	toSerialize["success"] = o.Success
	return toSerialize, nil
}

type NullableCloneResult struct {
	value *CloneResult
	isSet bool
}

func (v NullableCloneResult) Get() *CloneResult {
	return v.value
}

func (v *NullableCloneResult) Set(val *CloneResult) {
	v.value = val
	v.isSet = true
}

func (v NullableCloneResult) IsSet() bool {
	return v.isSet
}

func (v *NullableCloneResult) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCloneResult(val *CloneResult) *NullableCloneResult {
	return &NullableCloneResult{value: val, isSet: true}
}

func (v NullableCloneResult) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCloneResult) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


